 /*
 * file      : src/win_adj_time.c
 * project   : tm
 * with      : Gtk-2
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TM - Edition des heures de travail / Edition of working hours
 * GNU General Public License
 * 
 * This file is part of TM.
 * 
 * TM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * TM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with TM.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
	#define gettext_noop(x) (x) 
#endif

#include <gtk/gtk.h>
#include <stdlib.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_tm/lib.h"
#endif

#include "global.h"
#include "callbacks.h"
#include "win_adj_time.h"



typedef struct {

	GtkWidget	*AdrWin;					// Adresse de la fenetre
	gboolean	IsShow;						// TRUE or FALSE
	GtkWidget	*AdrComboboxAdjustTime;				// Adresse combobox
	
	GtkWidget	*Adr_spinbutton_adjust_time_matin_debut_h;	// Adresse 
	GtkWidget	*Adr_spinbutton_adjust_time_matin_debut_mn;	// Adresse 
	GtkWidget	*Adr_spinbutton_adjust_time_matin_fin_h;	// Adresse 
	GtkWidget	*Adr_spinbutton_adjust_time_matin_fin_mn;	// Adresse 
	
	GtkWidget	*Adr_spinbutton_adjust_time_soir_debut_h;	// Adresse 
	GtkWidget	*Adr_spinbutton_adjust_time_soir_debut_mn;	// Adresse 
	GtkWidget	*Adr_spinbutton_adjust_time_soir_fin_h;		// Adresse 
	GtkWidget	*Adr_spinbutton_adjust_time_soir_fin_mn;	// Adresse 
		
	GtkWidget	*AdrComboboxChoiceMonthAdjustTime;		// Adresse 
} VAR_WIN_ADJ_TIME;

VAR_WIN_ADJ_TIME VarWinAdjTime = { 
	
	NULL,		// GtkWidget	*AdrWin
	FALSE,		// gboolean	IsShow
	NULL,		// GtkWidget	*AdrComboboxAdjustTime
	
	NULL,		// GtkWidget	*Adr_spinbutton_adjust_time_matin_debut_h
	NULL,		// GtkWidget	*Adr_spinbutton_adjust_time_matin_debut_m
	NULL,		// GtkWidget	*Adr_spinbutton_adjust_time_matin_fin_h
	NULL,		// GtkWidget	*Adr_spinbutton_adjust_time_matin_fin_mn
	NULL,		// GtkWidget	*Adr_spinbutton_adjust_time_soir_debut_h
	NULL,		// GtkWidget	*Adr_spinbutton_adjust_time_soir_debut_mn
	NULL,		// GtkWidget	*Adr_spinbutton_adjust_time_soir_fin_h
	NULL		// GtkWidget	*Adr_spinbutton_adjust_time_soir_fin_mn
	
	};


// 
// 
gboolean on_window_adjust_time_destroy_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	VarWinAdjTime.IsShow = FALSE;
	gtk_widget_hide( VarWinAdjTime.AdrWin );
	return (TRUE);
}
// 
// 
gboolean on_window_adjust_time_delete_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	VarWinAdjTime.IsShow = FALSE;
	gtk_widget_hide( VarWinAdjTime.AdrWin );
	return (TRUE);
}
// 
// 
void on_combobox_adjust_time_changed( GtkComboBox *combobox, gpointer user_data )
{
	gint	MatinDebut;
	gint	MatinFin;
	gint	SoirDebut;
	gint	SoirFin;
	gchar	*Comment = NULL;
	gint	DayComboBox;
	
	if( NULL != VarWinAdjTime.AdrComboboxAdjustTime ) {
		
		DayComboBox = gtk_combo_box_get_active( GTK_COMBO_BOX(VarWinAdjTime.AdrComboboxAdjustTime) );
		edit_get_DayAdjust( DayComboBox, &MatinDebut, &MatinFin, &SoirDebut, &SoirFin, &Comment );
		// g_print( "CHOIX JOUR = %s\n", libutils_get_day( DayComboBox ));
		
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_h), MatinDebut / 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_mn), MatinDebut % 60 );
		
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_h), MatinFin / 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_mn), MatinFin % 60 );
		
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_h), SoirDebut / 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_mn), SoirDebut % 60 );
		
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_h), SoirFin / 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_mn), SoirFin % 60 );
	}
}
// 
// 
void on_combobox_adjust_time_realize( GtkWidget *widget, gpointer user_data )
{
	gint	Day;
	
	libcombo_alloc (GTK_COMBO_BOX (widget));
	
	for( Day = 0; Day < 7; Day ++ ) {
		gtk_combo_box_append_text( GTK_COMBO_BOX(widget), libutils_get_day( Day ));
	}
	gtk_combo_box_set_active (GTK_COMBO_BOX (widget),0 );
	VarWinAdjTime.AdrComboboxAdjustTime = widget;
}
// 
// 
void on_button_ok_adjust_time_clicked( GtkButton *button, gpointer user_data )
{
	VarWinAdjTime.IsShow = FALSE;
	gtk_widget_hide( VarWinAdjTime.AdrWin );
	edit_apply_weeks( (gint)gtk_combo_box_get_active( GTK_COMBO_BOX(VarWinAdjTime.AdrComboboxChoiceMonthAdjustTime) ) );
}
// 
// 
void on_button_cancel_adjust_time_clicked( GtkButton *button, gpointer user_data )
{
	VarWinAdjTime.IsShow = FALSE;
	gtk_widget_hide( VarWinAdjTime.AdrWin );
}
// 
// 
void on_button_apply_adjust_time_clicked( GtkButton *button, gpointer user_data )
{
	edit_apply_weeks( (gint)gtk_combo_box_get_active( GTK_COMBO_BOX(VarWinAdjTime.AdrComboboxChoiceMonthAdjustTime) ) );
}
// 
// 
void on_label_day_adjust_time_realize( GtkWidget *widget, gpointer user_data )
{
	gchar	*Str = NULL;
	
	Str = g_strdup_printf( "<b>%s\n%s\n%s\n%s\n%s\n%s\n%s</b>",
			libutils_get_day( 0 ),
			libutils_get_day( 1 ),
			libutils_get_day( 2 ),
			libutils_get_day( 3 ),
			libutils_get_day( 4 ),
			libutils_get_day( 5 ),
			libutils_get_day( 6 )
			);
	gtk_label_set_label( GTK_LABEL(widget), Str );
	g_free( Str );
	Str = NULL;
}
void VarWinAdjTime_set_label_hours( void )
{
	gint	Day;
	gint	MatinDebut;
	gint	MatinFin;
	gint	SoirDebut;
	gint	SoirFin;
	gchar	*Comment = NULL;
	GString	*gstr = NULL;
	
	gstr = g_string_new( NULL );
	
	for( Day = 0; Day < 7; Day ++ ) {
		edit_get_DayAdjust( Day, &MatinDebut, &MatinFin, &SoirDebut, &SoirFin, &Comment );
		
		g_string_append_printf( gstr, "%02dh%02d  %02dh%02d  -  %02dh%02d  %02dh%02d",
				MatinDebut / 60,
				MatinDebut % 60,
				MatinFin / 60,
				MatinFin % 60,
				SoirDebut / 60,
				SoirDebut % 60,
				SoirFin / 60,
				SoirFin % 60
				);
		if( Day < 6 )
			g_string_append_printf( gstr, "\n" );
	}
	// gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_hours_adjust_time")), gstr->str );
	gtk_label_set_markup( GTK_LABEL(GLADE_GET_OBJECT("label_hours_adjust_time")), gstr->str );
	
	g_string_free( gstr, TRUE );
}
// 
// 
void on_combobox_choice_month_adjust_time_realize( GtkWidget *widget, gpointer user_data )
{
	gint	Month;
	
	libcombo_alloc (GTK_COMBO_BOX (widget));
	
	gtk_combo_box_append_text( GTK_COMBO_BOX(widget), "Tous les mois" );
	for( Month = 0; Month < 12; Month ++ ) {
		gtk_combo_box_append_text( GTK_COMBO_BOX(widget), libutils_get_str_month( Month ));
	}
	gtk_combo_box_set_active (GTK_COMBO_BOX (widget),0 );
	VarWinAdjTime.AdrComboboxChoiceMonthAdjustTime = widget;
}
// 
// 
void WinAdjTime_init_spinbuttons( void )
{
	gint	IndiceComboBox;
	gint	MatinDebut;
	gint	MatinFin;
	gint	SoirDebut;
	gint	SoirFin;
	gchar	*Comment = NULL;
	
	IndiceComboBox = gtk_combo_box_get_active( GTK_COMBO_BOX(VarWinAdjTime.AdrComboboxAdjustTime) );
	edit_get_DayAdjust( IndiceComboBox, &MatinDebut, &MatinFin, &SoirDebut, &SoirFin, &Comment );
	
	if( NULL != VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_h &&
	    NULL != VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_mn &&
	    NULL != VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_h &&
	    NULL != VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_mn &&
	    NULL != VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_h &&
	    NULL != VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_mn &&
	    NULL != VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_h &&
	    NULL != VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_mn
	    ) {
		
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_h),  MatinDebut / 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_mn), MatinDebut % 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_h),    MatinFin / 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_mn),   MatinFin % 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_h),   SoirDebut / 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_mn),  SoirDebut % 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_h),     SoirFin / 60 );
		gtk_spin_button_set_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_mn),    SoirFin % 60 );
	}
}
void on_spinbutton_adjust_time_matin_debut_h_realize( GtkWidget *widget, gpointer user_data )
{
	VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_h = widget;
	WinAdjTime_init_spinbuttons();
}
void on_spinbutton_adjust_time_matin_debut_mn_realize( GtkWidget *widget, gpointer user_data )
{
	VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_mn = widget;
	WinAdjTime_init_spinbuttons();
}
void on_spinbutton_adjust_time_matin_fin_h_realize( GtkWidget *widget, gpointer user_data )
{
	VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_h = widget;
	WinAdjTime_init_spinbuttons();
}
void on_spinbutton_adjust_time_matin_fin_mn_realize( GtkWidget *widget, gpointer user_data )
{
	VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_mn = widget;
	WinAdjTime_init_spinbuttons();
}
void on_spinbutton_adjust_time_soir_debut_h_realize( GtkWidget *widget, gpointer user_data )
{
	VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_h = widget;
	WinAdjTime_init_spinbuttons();
}
void on_spinbutton_adjust_time_soir_debut_mn_realize( GtkWidget *widget, gpointer user_data )
{
	VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_mn = widget;
	WinAdjTime_init_spinbuttons();
}
void on_spinbutton_adjust_time_soir_fin_h_realize( GtkWidget *widget, gpointer user_data )
{
	VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_h = widget;
	WinAdjTime_init_spinbuttons();
}
void on_spinbutton_adjust_time_soir_fin_mn_realize( GtkWidget *widget, gpointer user_data )
{
	VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_mn = widget;
	WinAdjTime_init_spinbuttons();
}


// 
// 
void on_spinbutton_adjust_time_value_changed( GtkSpinButton *spinbutton, gpointer user_data )
{
	gint	IndiceComboBox;
	gint	Minutes;

	if( NULL != VarWinAdjTime.AdrComboboxAdjustTime ) {
		IndiceComboBox = gtk_combo_box_get_active( GTK_COMBO_BOX(VarWinAdjTime.AdrComboboxAdjustTime) );
	}
	else return;	
	
	if( NULL == VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_h ||
	    NULL == VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_mn ||
	    NULL == VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_h ||
	    NULL == VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_mn ||
	    NULL == VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_h ||
	    NULL == VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_mn ||
	    NULL == VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_h ||
	    NULL == VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_mn ) return;
	
	// AJUSTE LA LIMITE INFERIEURE DE
	// 	MATIN_FIN
	// 	SOIR_DEBUT
	// 	SOIR_FIN
	gtk_spin_button_set_range(
			GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_h),
			gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_h)),
			23
			);
	gtk_spin_button_set_range(
			GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_h),
			gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_h)),
			23
			);
	gtk_spin_button_set_range(
			GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_h),
			gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_h)),
			23
			);
	
	// MATIN DEBUT
	if( spinbutton == GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_h) || spinbutton == GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_mn) ) {
		
		Minutes = (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_h) );
		Minutes *= 60;
		Minutes += (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_debut_mn) );
		edit_set_DayAdjust( IndiceComboBox, Minutes, -1, -1, -1, NULL );
	}
	
	// MATIN FIN
	else if( spinbutton == GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_h) || spinbutton == GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_mn)) {
		
		Minutes = (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_h) );
		Minutes *= 60;
		Minutes += (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_matin_fin_mn) );
		edit_set_DayAdjust( IndiceComboBox, -1, Minutes, -1, -1, NULL );
	}
	
	// SOIR DEBUT
	else if( spinbutton == GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_h) || spinbutton == GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_mn)) {
		
		Minutes = (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_h) );
		Minutes *= 60;
		Minutes += (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_debut_mn) );
		edit_set_DayAdjust( IndiceComboBox, -1, -1, Minutes, -1, NULL );
	}
	
	// SOIR FIN
	else if( spinbutton == GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_h) || spinbutton == GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_mn)) {
		
		Minutes  = (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_h) ) * 60;
		Minutes += (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarWinAdjTime.Adr_spinbutton_adjust_time_soir_fin_mn) );
		edit_set_DayAdjust( IndiceComboBox, -1, -1, -1, Minutes, NULL );
	}

	VarWinAdjTime_set_label_hours();
}
// 
// 
void WinAdjTime_open( void )
{
	if( TRUE == VarWinAdjTime.IsShow ) {
		gdk_window_raise( VarWinAdjTime.AdrWin->window );
	}
	else {
		if( NULL == VarWinAdjTime.AdrWin ) {
			VarWinAdjTime.AdrWin = GTK_WIDGET(GLADE_GET_OBJECT("window_adjust_time"));
			gtk_builder_connect_signals( GtkBuilderProjet, NULL );
		}
		gtk_window_set_transient_for( GTK_WINDOW(VarWinAdjTime.AdrWin), GTK_WINDOW(WindMain) );
		gtk_window_set_modal( GTK_WINDOW(VarWinAdjTime.AdrWin), TRUE );
		libutils_set_default_icone_to_win( VarWinAdjTime.AdrWin );
		gtk_window_set_title( GTK_WINDOW( VarWinAdjTime.AdrWin ), "Time Management" );
		gtk_window_set_position( GTK_WINDOW(VarWinAdjTime.AdrWin), GTK_WIN_POS_CENTER );
		gtk_widget_show( VarWinAdjTime.AdrWin );
		VarWinAdjTime.IsShow = TRUE;
		VarWinAdjTime_set_label_hours();
	}
}












